package com.company.demoresources.screen.filerefdescriptor;

import com.company.demoresources.jscomponent.DemoGallery;
import com.vaadin.ui.AbstractOrderedLayout;
import io.jmix.ui.component.FileStorageResource;
import io.jmix.ui.component.HBoxLayout;
import io.jmix.ui.model.CollectionContainer;
import io.jmix.ui.screen.*;
import com.company.demoresources.entity.FileRefDescriptor;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("FileRefDescriptor.browse")
@UiDescriptor("file-ref-descriptor-browse.xml")
@LookupComponent("fileRefDescriptorsTable")
public class FileRefDescriptorBrowse extends StandardLookup<FileRefDescriptor> {
    @Autowired
    protected CollectionContainer<FileRefDescriptor> fileRefDescriptorsDc;

    @Autowired
    protected HBoxLayout demoGalleryBox;

    @Subscribe
    protected void onAfterShow(final AfterShowEvent event) {
        DemoGallery demoGallery = new DemoGallery();
        demoGallery.setSizeFull();

        for (FileRefDescriptor item : fileRefDescriptorsDc.getItems()) {
            FileStorageResource resource = getApplicationContext().getBean(FileStorageResource.class);
            resource.setFileReference(item.getFileRef());
            demoGallery.addFileStorageResource(resource);
        }

        demoGalleryBox.unwrap(AbstractOrderedLayout.class).addComponent(demoGallery);
    }
}